"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
let RefererGuard = class RefererGuard {
    constructor(reflector) {
        this.reflector = reflector;
    }
    canActivate(context) {
        const request = context.switchToHttp().getRequest();
        const requestReferer = request.headers.referer;
        console.log(requestReferer);
        const referers = this.reflector.get('referers', context.getHandler());
        console.log(referers);
        for (let referer of referers) {
            const refererRegex = this.produceRefererRegex(referer);
            console.log(refererRegex);
            const match = requestReferer.match(refererRegex);
            console.log(match);
            if (match)
                return true;
        }
        return false;
    }
    produceRefererRegex(referer) {
        referer = referer.replace(/\*/g, "(\\S*)");
        const refererRegex = new RegExp("^" + referer + "$", "gm");
        return refererRegex;
    }
};
RefererGuard = __decorate([
    common_1.Injectable(),
    __metadata("design:paramtypes", [core_1.Reflector])
], RefererGuard);
exports.RefererGuard = RefererGuard;
